# wxHScrolledWindow Class Reference
[Miscellaneous Windows]

`#include <wx/vscroll.h>`

Inheritance diagram for wxHScrolledWindow:
[legend]

## Detailed Description

In the name of this class, "H" stands for "horizontal" because it can be used for scrolling columns of variable widths.

It is not necessary to know the widths of all columns in advance -- only those which are shown on the screen need to be measured.

In any case, this is a generalization of wxScrolled which can be only used when all columns have the same widths. It lacks some other wxScrolled features however, notably it can't scroll specific pixel sizes of the window or its exact client area size.

To use this class, you need to derive from it and implement the OnGetColumnWidth() pure virtual method. You also must call SetColumnCount() to let the base class know how many columns it should display, but from that moment on the scrolling is handled entirely by wxHScrolledWindow. You only need to draw the visible part of contents in your `OnPaint()` method as usual. You should use GetVisibleColumnsBegin() and GetVisibleColumnsEnd() to select the lines to display. Note that the device context origin is not shifted so the first visible column always appears at the point (0, 0) in physical as well as logical coordinates.

##

Library: wxCore

Category: Miscellaneous Windows

See also:
  wxHVScrolledWindow, wxVScrolledWindow

## Public Member Functions
| wxHScrolledWindow ()
| Default constructor, you must call Create() later.
| wxHScrolledWindow (wxWindow *parent, wxWindowID id=wxID_ANY, const wxPoint &pos=wxDefaultPosition, const wxSize &size=wxDefaultSize, long style=0, const wxString &name=wxPanelNameStr)
| This is the normal constructor, no need to call Create() after using this constructor.
bool | Create (wxWindow *parent, wxWindowID id=wxID_ANY, const wxPoint &pos=wxDefaultPosition, const wxSize &size=wxDefaultSize, long style=0, const wxString &name=wxPanelNameStr)
| Same as the non-default constructor, but returns a status code: true if ok, false if the window couldn't be created.

List of all members.

## Constructor & Destructor Documentation

wxHScrolledWindow::wxHScrolledWindow | ( |  | ) |

Default constructor, you must call Create() later.

wxHScrolledWindow::wxHScrolledWindow | ( | wxWindow * | parent,
|  | wxWindowID | id = `wxID_ANY`,
|  | const wxPoint & | pos = `wxDefaultPosition`,
|  | const wxSize & | size = `wxDefaultSize`,
|  | long | style = `0`,
|  | const wxString & | name = `wxPanelNameStr` |
| ) |  |  |

This is the normal constructor, no need to call Create() after using this constructor.

Note:
  `wxHSCROLL` is always automatically added to the style, there is no need to specify it explicitly.

Parameters:

  | parent | The parent window, must not be NULL.
  | id | The identifier of this window, wxID_ANY by default.
  | pos | The initial window position.
  | size | The initial window size.
  | style | The window style. There are no special style bits defined for this class.
  | name | The name for this window; usually not used.

## Member Function Documentation

bool wxHScrolledWindow::Create | ( | wxWindow * | parent,
|  | wxWindowID | id = `wxID_ANY`,
|  | const wxPoint & | pos = `wxDefaultPosition`,
|  | const wxSize & | size = `wxDefaultSize`,
|  | long | style = `0`,
|  | const wxString & | name = `wxPanelNameStr` |
| ) |  |  |

Same as the non-default constructor, but returns a status code: true if ok, false if the window couldn't be created.

Just as with the constructor, the `wxHSCROLL` style is always used, there is no need to specify it explicitly.

Reimplemented from wxPanel.

|  | [ top ]